<?php

namespace App\Data;

use http\Url;

/**
 * This class implements the User and
 */
class AccountUser implements User {
    private string $name;
    private Url $profilePicture;
    private int $age;

    /**
     * @param string $name
     * @param Url $profilePicture
     * @param int $age
     */
    public function __construct(string $name, Url $profilePicture, int $age) {
        $this->name = $name;
        $this->profilePicture = $profilePicture;
        $this->age = $age;
    }


    public function getName(): string {
        return $this->name;
    }

    public function getProfilePicture(): Url {
        return $this->profilePicture;
    }

    public function getAge(): int {
        return $this->age;
    }

    public function setName(string $name) {
        $this->name = $name;
    }

    public function setProfilePicture(Url $profilePicture) {
        $this->profilePicture = $profilePicture;
    }

    public function setAge(int $age) {
        $this->age = $age;
    }


}