<?php

namespace App\Data;

use http\Url;

class Team {
    private string $name;
    private Url $picture;
    private Color $mainColor;
    private Color $secondColor;

    /**
     * @var array maps users with their role
     */
    private array $members;

    /**
     * @param string $name
     * @param Url $picture
     * @param Color $mainColor
     * @param Color $secondColor
     * @param array $members
     */
    public function __construct(string $name, Url $picture, Color $mainColor, Color $secondColor, array $members) {
        $this->name = $name;
        $this->picture = $picture;
        $this->mainColor = $mainColor;
        $this->secondColor = $secondColor;
        $this->members = $members;
    }

    /**
     * @return string
     */
    public function getName(): string {
        return $this->name;
    }

    /**
     * @return Url
     */
    public function getPicture(): Url {
        return $this->picture;
    }

    /**
     * @return Color
     */
    public function getMainColor(): Color {
        return $this->mainColor;
    }

    /**
     * @return Color
     */
    public function getSecondColor(): Color {
        return $this->secondColor;
    }

    public function listMembers(): array {
        return array_map(fn ($id, $role) => new Member($id, $role), $this->members);
    }

}