<?php

namespace App\Gateway;

use App\Connexion;
use App\Data\Color;
use PDO;

class TeamGateway /* retourne exception par rapport à la validité du paramètre par ex. un int qui ne peut pas etre <0 doit etre verif etsoulever une exception */
{
    private Connexion $con;

    public function __construct(Connexion $con) {
        $this->con = $con;
    }

    public function insert(string $name, string $picture, Color $mainColor, Color $secondColor) {
        $this->con->exec(
            "INSERT INTO Team VALUES (:name, :picture, :mainColor, :secondColor)",
            [
                ":name" => [$name, PDO::PARAM_STR],
                ":picture" => [$picture, PDO::PARAM_STR],
                ":mainColor" => [$mainColor, PDO::PARAM_STR],
                ":secondColor" => [$secondColor, PDO::PARAM_STR]
            ]
        );
    }

    public function listByName(string $name): array {
        return $this->con->fetch(
            "SELECT name,picture,mainColor,secondColor FROM Team WHERE name LIKE '% :thing %' ",
            [
                ":thing" => [$name, PDO::PARAM_STR]
            ]
        );
    }

}